/*********************************************************************************
*Ȩ			ѶƼڣ޹˾
*ļ:			tpgDecoder.h
*:			ʫ
*汾:			v1.0
*:			2017.11.08
*:		TPG
**********************************************************************************/

#ifndef __TPGDECODER_H__
#define __TPGDECODER_H__

#ifndef WIN32
#define DLLEX __attribute__ ((visibility ("default")))

#else
#define DLLEX __declspec(dllexport)
#endif

#define MAX_LAYER_NUM	3
#define MAX_WIDTH	16383
#define MAX_HEIGHT  16383

#ifndef TPG_RAW_DATA_FORMAT
#define TPG_RAW_DATA_FORMAT

#define IMAGE_SUPPLEMENT_DATA 0x000001BA
#define IMAGE_USER_DATA 0x000001BD


typedef enum tagRawDataFormat
{
	FORMAT_YUV = 0,
	FORMAT_RGB = 1,
	FORMAT_BGR = 2,
	FORMAT_RGBA = 3,
	FORMAT_BGRA = 4,
	FORMAT_NV21 = 5,
	FORMAT_RGBA_BLEND_ALPHA = 6, //RGB*alpha
}enRawDataFormat;

typedef enum TPGStatusCode {
    TPG_STATUS_OK = 0,
    TPG_STATUS_OUT_OF_MEMORY,
    TPG_STATUS_INVALID_PARAM,
    TPG_STATUS_BITSTREAM_ERROR,
    TPG_STATUS_UNSUPPORTED_FEATURE,
    TPG_STATUS_SUSPENDED,
    TPG_STATUS_USER_ABORT,
    TPG_STATUS_NOT_ENOUGH_DATA,
    TPG_STATUS_INIT_ERROR
} TPGStatusCode;


typedef	enum enumImageMode
{
    emMode_Normal = 0,				//̬ͼƬʽΪRGBݣ
    emMode_EncodeAlpha = 1,			//Alpha̬ͨͼƬʽΪRGBAݣ
    emMode_BlendAlpha = 2,			//AlphaͨAlphaֱͨRGBݺϳˣRGBݣ
    emMode_Animation = 3,			//̬ͼƬʽAlpha
	emMode_AnimationWithAlpha = 4,	//̬ͼƬʽAlpha
}enumImageMode;

#endif

typedef struct _TPGFeatures
{
	int header_size;			//TPGļͷȣ
    int width;					//TPGͼƬ
    int height;					//TPGͼƬ߶
    enumImageMode image_mode;	//TPGļ
    int version;				//TPGļʽ汾
	int frame_count;			//TPGļͼ̬֡ͼƬΪ1
    int reserved[10];			//λ
}TPGFeatures;

typedef struct _TPGOutFrame
{
	unsigned char* pOutBuf;		//RGBݻַ 
	int bufsize;				// С
    int dstWidth;				// ͼƬĿĿ
    int dstHeight;				// ͼƬĿĸ߶
    enRawDataFormat fmt;		// ͼƬ
    int delayTime;				// ǰͼƬʾӳʱ䣨ֻԶ̬ͼƬЧ
}TPGOutFrame;

typedef struct _TPGVersion {
	int num;
	char str[20];
}TPGVersion;

#ifdef __cplusplus
extern "C" {
#endif

	//==================================================================
	//	TPGDecCreate
	//ܣ		TPG
	//	pData	TPG
	//			len[in]	TPG
	//ֵ	ͣvoid*)
	//          TPGɹNULL
	//޸ļ¼
	//==================================================================
    DLLEX void* TPGDecCreate(const unsigned char* pData, int len);


	//==================================================================
	//	TPGDecDestroy
	//ܣ		TPG
	//
	//			h	TPG
	//ֵ	ͣvoid)
	//޸ļ¼
	//==================================================================
	DLLEX void TPGDecDestroy(void* h);

	//==================================================================
	//	TPGDecodeImage
	//ܣ		һ֡ͼ
	//
	//			hDec	TPG
	//			pData	TPG
	//			len	    TPG
	//			index	̬֡ͼƬֵΪ0ڶͼʾindex֡ͼ
	//
	//			pDecFrame	֡ߵϢ
	//ֵ	ͣTPGStatusCode)
	//          ɹTPG_STATUS_OK򷵻ضӦ롣
	//޸ļ¼
	//==================================================================
	DLLEX TPGStatusCode TPGDecodeImage(void* hDec, const unsigned char* pData, int len, int index, TPGOutFrame *pDecFrame);

	//==================================================================
	//	TPGParseHeader
	//ܣ		ͷļ
	//
	//			pData	TPG
	//			len	    TPG
	//
	//			pFeatures	TPGļϢ
	//ֵ	ͣTPGStatusCode)
	//          ǰļΪTPGļTPG_STATUS_OK򷵻ضӦ롣
	//޸ļ¼
	//==================================================================
	DLLEX TPGStatusCode TPGParseHeader(const unsigned char* pData, int len, TPGFeatures* pFeatures);

	//==================================================================
	//	TPGGetDelayTime
	//ܣ		ȡǰ֡ͼʾӳʱ䣨ýӿֻж̬ͼƬЧ
	//
	//			hDec	TPG
	//			pData	TPG
	//			len	    TPG
	//			index	̬֡ͼƬֵΪ0ڶͼʾindex֡ͼ
	//
	//			pDelayTime	Ӧ֡ʾӳʱ
	//ֵ	ͣTPGStatusCode)
	//          ȡTPG_STATUS_OK򷵻ضӦ롣
	//޸ļ¼
	//==================================================================
	DLLEX TPGStatusCode TPGGetDelayTime(void* hDec, const unsigned char* pData, int len, int index, int* pDelayTime);

	//==================================================================
	//	TPGCanDecode
	//ܣ		⵱ǰǷ㹻
	//
	//			hDec	TPG
	//			pData	TPG
	//			len	    TPG
	//			index	̬֡ͼƬֵΪ0ڶͼʾindex֡ͼ
	//ֵ	ͣTPGStatusCode)
	//			index֡ܽ뷵TPG_STATUS_OK򷵻ضӦ롣
	//޸ļ¼
	//==================================================================
	DLLEX TPGStatusCode TPGCanDecode(void* hDec,  const unsigned char* pData, int len, int index);

	//==================================================================
	//	TPGGetAdditionalInfo
	//ܣ		ȡTPGеûϢ(EXIF)
	//
	//			hDec		TPG
	//			pInData		TPG
	//			nInDatalen	TPG
	//			nIdentity	Ϣʶ
	//
	//			pOutData	Ϣ׵ַûзNULLڴ治ҪӦò
	//			pOutDataLen	Ӧ֡ʾӳʱ䣨Ϣȣ
	//ֵ	ͣTPGStatusCode)
	//          ȡӦϢTPG_STATUS_OK򷵻ضӦ롣
	//޸ļ¼
	//==================================================================
	DLLEX TPGStatusCode TPGGetAdditionalInfo(void* hDec, const unsigned char* pInData, int nInDatalen, int nIdentity, const unsigned char** pOutData, int* pOutDataLen);

	//==================================================================
	//	TPGDecGetAverageQP
	//ܣ		ȡTPGQP
	//	
	//ֵ	ͣfloat)
	//			ضӦQPֵ
	//޸ļ¼
	//==================================================================
	DLLEX float TPGDecGetAverageQP(void* hDec);

	//==================================================================
	//	TPGDecGetVersion
	//ܣ		ȡTPG汾
	//	
	//ֵ	ͣintstring)
	//			ضӦ汾š
	//޸ļ¼
	//==================================================================
	DLLEX TPGVersion TPGDecGetVersion();
#ifdef __cplusplus
};
#endif


#endif	// __TPGDEC_H__
